/*

  Copyright 2006-2016 by

  Laboratoire de l'Informatique du Parallelisme,
  UMR CNRS - ENS Lyon - UCB Lyon 1 - INRIA 5668,

  LORIA (CNRS, INPL, INRIA, UHP, U-Nancy 2),

  Laboratoire d'Informatique de Paris 6 - Équipe PEQUAN
  Sorbonne Universités
  UPMC Univ Paris 06
  UMR 7606, LIP6
  Boîte Courrier 169
  4, place Jussieu
  F-75252 Paris Cedex 05
  France

  and by

  Centre de recherche INRIA Sophia Antipolis Mediterranee, equipe APICS, Sophia Antipolis, France.

  Contributors Ch. Lauter, S. Chevillard

  christoph.lauter@christoph-lauter.org
  sylvain.chevillard@ens-lyon.org

  This software is a computer program whose purpose is to provide an
  environment for safe floating-point code development. It is
  particularly targeted to the automated implementation of
  mathematical floating-point libraries (libm). Amongst other features,
  it offers a certified infinity norm, an automatic polynomial
  implementer and a fast Remez algorithm.

  This software is governed by the CeCILL-C license under French law and
  abiding by the rules of distribution of free software.  You can  use,
  modify and/or redistribute the software under the terms of the CeCILL-C
  license as circulated by CEA, CNRS and INRIA at the following URL
  "http://www.cecill.info".

  As a counterpart to the access to the source code and  rights to copy,
  modify and redistribute granted by the license, users are provided only
  with a limited warranty  and the software's author,  the holder of the
  economic rights,  and the successive licensors  have only  limited
  liability.

  In this respect, the user's attention is drawn to the risks associated
  with loading,  using,  modifying and/or developing or reproducing the
  software by the user in light of its specific status of free software,
  that may mean  that it is complicated to manipulate,  and  that  also
  therefore means  that it is reserved for developers  and  experienced
  professionals having in-depth computer knowledge. Users are therefore
  encouraged to load and test the software's suitability as regards their
  requirements in conditions enabling the security of their systems and/or
  data to be ensured and,  more generally, to use and operate it in the
  same conditions as regards security.

  The fact that you are presently reading this means that you have had
  knowledge of the CeCILL-C license and that you accept its terms.

  This program is distributed WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

#ifndef VERSION_H
#define VERSION_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#else
#define PACKAGE_BUGREPORT error@error.com
#endif

#define VERSION_COPYRIGHT_YEARS "2006-2022"
#define VERSION_COPYRIGHT_TEXT                                          \
  "Copyright " VERSION_COPYRIGHT_YEARS " by\n"                          \
  "\n"                                                                  \
  "   Laboratoire de l'Informatique du Parallelisme,\n"                 \
  "   UMR CNRS - ENS Lyon - UCB Lyon 1 - INRIA 5668,\n"                 \
  "\n"                                                                  \
  "   LORIA (CNRS, INPL, INRIA, UHP, U-Nancy 2),\n"                     \
  "\n"                                                                  \
  "   Laboratoire d'Informatique de Paris 6, equipe PEQUAN,\n"          \
  "   UPMC Universite Paris 06 - CNRS - UMR 7606 - LIP6, Paris, France,\n" \
  "\n"                                                                  \
  "   Laboratoire d'Informatique de Paris 6 - Équipe PEQUAN\n"          \
  "   Sorbonne Universités\n"                                           \
  "   UPMC Univ Paris 06\n"                                             \
  "   UMR 7606, LIP6\n"                                                 \
  "   Boîte Courrier 169\n"                                             \
  "   4, place Jussieu\n"                                               \
  "   F-75252 Paris Cedex 05\n"                                         \
  "   France,\n"                                                        \
  "\n"                                                                  \
  "   Sorbonne Université\n"                                            \
  "   CNRS, Laboratoire d'Informatique de Paris 6, LIP6\n"              \
  "   F - 75005 Paris\n"                                                \
  "   France,\n"                                                        \
  "\n"                                                                  \
  "   CNRS, LIP6, UPMC\n"                                               \
  "   Sorbonne Universités, UPMC Univ Paris 06,\n"                      \
  "   CNRS, LIP6 UMR 7606, 4 place Jussieu 75005 Paris,\n"               \
  "\n"                                                                  \
  "   University of Alaska Anchorage, College of Engineering\n"               \
  "\n"                                                                  \
  "and by\n"                                                            \
  "\n"                                                                  \
  "   Centre de recherche INRIA Sophia Antipolis Mediterranee,\n"       \
  "   Equipes APICS, FACTAS,\n"                                         \
  "   Sophia Antipolis, France.\n"                                      \
  "\n"                                                                  \
  "All rights reserved.\n"                                              \
  "\n"                                                                  \
  "Contributors:\n"                                                     \
  "   Ch. Lauter, \n"                                                   \
  "   S. Chevillard, \n"                                                \
  "   M. Joldes, \n"                                                    \
  "   N. Jourdan, \n"                                                   \
  "   M. Mezzarobba, \n"                                                \
  "   J. Benoit.\n"                                                     \
  " \n"                                                                 \
  "License:\n"                                                          \
  "   This software is governed by the CeCILL-C license under French law and\n"   \
  "   abiding by the rules of distribution of free software. You can use,\n"      \
  "   modify and/or redistribute the software under the terms of the CeCILL-C\n"  \
  "   license as circulated by CEA, CNRS and INRIA at the following URL\n"        \
  "   \"http://www.cecill.info\".\n"                                              \
  "\n"                                                                            \
  "   As a counterpart to the access to the source code and rights to copy,\n"    \
  "   modify and redistribute granted by the license, users are provided only\n"  \
  "   with a limited warranty and the software's author, the holder of the\n"     \
  "   economic rights, and the successive licensors have only limited\n"          \
  "   liability.\n"                                                               \
  "\n"                                                                            \
  "   In this respect, the user's attention is drawn to the risks associated\n"   \
  "   with loading, using, modifying and/or developing or reproducing the\n"      \
  "   software by the user in light of its specific status of free software,\n"   \
  "   that may mean that it is complicated to manipulate, and that also\n"        \
  "   therefore means that it is reserved for developers and experienced\n"       \
  "   professionals having in-depth computer knowledge. Users are therefore\n"    \
  "   encouraged to load and test the software's suitability as regards their\n"  \
  "   requirements in conditions enabling the security of their systems and/or\n" \
  "   data to be ensured and, more generally, to use and operate it in the\n"    \
  "   same conditions as regards security.\n"                                     \
  "\n"                                                                            \
  "   The fact that you are presently reading this means that you have had\n"     \
  "   knowledge of the CeCILL-C license and that you accept its terms.\n"         \
  "\n"                                                                            \
  "   This program is distributed WITHOUT ANY WARRANTY; without even the\n"       \
  "   implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n" \
  "\n"

#endif /* ifdef VERSION_H*/
